import { type TInjectedFile } from './file/FileManager';
import { type TSfyr } from './sfyr/Types-TypeMapAccessor';
import { type IStorage } from './storage/IStorage';
import { type CoreFile, type CoreFileMapOf } from './Types-Injected';
/**
 * All the params that define how Stringifyr is initialized in an app
 */
export type TStringifyrParams<File extends CoreFile> = {
    apiKey: string;
    baseURL?: string;
    file: File;
    includeUnpublished?: boolean;
    defaults?: Partial<TInjectedFile<File>>;
    storageId?: string;
    storage?: IStorage;
    batchMS?: number;
    maxServerTimeMS?: number;
};
export declare function Stringifyr(params: TStringifyrParams<CoreFile>): TSfyr<any, any[], {}, false>;
export type TStringifyr = TSfyr<CoreFileMapOf<CoreFile>, [], {}, false>;
