import { type TFile } from '@stringifyrjs/lib/dist/src/lib/src/File';
import { type TFullyResolvedResolver } from '@stringifyrjs/lib/dist/src/lib/src/File';
import { type TResolver } from '@stringifyrjs/lib/dist/src/lib/src/Resolver';
import { type TGetTypeMapResolvers } from '@stringifyrjs/lib/dist/src/lib/src/TypeMap-Types';
import { type IStorage } from '../storage/IStorage';
import { type CoreFile, type CoreFileMap } from '../Types-Injected';
export type TInjectedFile<File extends CoreFile> = TFile<TGetTypeMapResolvers<CoreFileMap[File]> & string>;
type TFileManagerParams<File extends CoreFile> = {
    apiKey: string;
    baseURL: string;
    file: string;
    includeUnpublished?: boolean;
    defaults?: Partial<TInjectedFile<File>>;
    storageId?: string;
    storage?: IStorage;
    /**
     * Window for batching requests
     */
    batchMS: number;
    /**
     * After how long do we consider a local value "expired"
     */
    maxServerTimeMS?: number;
};
export declare class FileManager<File extends CoreFile> {
    private readonly fileStore;
    private readonly _fetch;
    private readonly batchMS;
    private readonly maxServerTimeMS;
    private get file();
    constructor(params: TFileManagerParams<File>);
    fetchMissingOrExpired(resolvers: TResolver[]): Promise<void>;
    resolve(resolver: keyof TInjectedFile<File> & TFullyResolvedResolver): import("../../../lib/src").TResolverValue;
    private fetchForced;
}
export {};
