import { type TFile } from '@stringifyrjs/lib/dist/src/lib/src/File';
import { type TResolverValue } from '@stringifyrjs/lib/dist/src/lib/src/Stringifyr-Types';
import { type IStorage } from '../storage/IStorage';
import { FileAccessor } from './FileAccessor';
type TFileObjectConstruct<File extends TFile> = {
    storageId: string;
    initialFile?: Partial<File>;
    storage?: IStorage;
};
/**
 * An abstraction over a Stringifyr file (TFile) that
 * simplifies controlling what is added to a file and what is pulled from a file.
 *
 * For example, each time assign is called, we want to buildGraph so by the time
 * there is a new render we can quickly access the wanted node.
 */
export declare class FileStore<File extends TFile> {
    readonly fileAccessor: FileAccessor<File>;
    private graph;
    constructor(params: TFileObjectConstruct<File>);
    assign(file: Partial<File>): void;
    resolve(resolver: keyof File & string): TResolverValue;
}
export {};
