import { type ResolverSegments, type TGetTypeMapResolvers, type TTypeMapOfChild, type TTypeMapVariablesForResolver } from '@stringifyrjs/lib/dist/src/lib/src/TypeMap-Types';
import { type FileManager } from '../file/FileManager';
import { type CoreFile, type CoreFileMapOf } from '../Types-Injected';
import { ResolverBatch } from './ResolverBatch';
import { type TCloneParams, type TMapper, type TSfyr, type TTypeMapVars } from './Types-TypeMapAccessor';
export type TStringifyrInstanceParams<File extends CoreFile, Path extends string[], Context extends Record<string, string>, Fetched extends boolean> = {
    context: Context;
    isFetched: Fetched;
    currentPath: Path;
    fileManager: FileManager<File>;
    resolverBatch: ResolverBatch<File>;
};
export type TAnyStringifyr = StringifyrInstance<any, string[], Record<string, string>, boolean>;
export declare class StringifyrInstance<File extends CoreFile, Path extends string[], Context extends Record<string, string>, Fetched extends boolean> {
    static build<File extends CoreFile, Path extends string[], Context extends Record<string, string>, Fetched extends boolean>(params: TStringifyrInstanceParams<File, Path, Context, Fetched>): TSfyr<CoreFileMapOf<File>, Path, Context, Fetched>;
    private readonly fileManager;
    private readonly resolverBatch;
    readonly context: Context;
    private readonly params;
    get fetched(): boolean;
    get value(): import("@stringifyrjs/lib/dist/src/lib/src").TResolverValue;
    private constructor();
    readonly withContext: <Vars extends Omit<TTypeMapVars<CoreFileMapOf<File>>, keyof Context>>(vars: Vars) => TSfyr<CoreFileMapOf<File>, Path, Context & Vars, Fetched>;
    readonly clone: <_Fetched extends boolean>(p: TCloneParams) => TSfyr<any, Path, Context, boolean>;
    readonly fetchBoundary: (p: TCloneParams) => TSfyr<any, Path, Context, boolean>;
    readonly fetch: () => Promise<TSfyr<CoreFileMapOf<File>, Path, Context, true>>;
    readonly resolve: <Resolver extends TGetTypeMapResolvers<CoreFileMapOf<File>>, Vars extends Partial<Omit<TTypeMapVariablesForResolver<CoreFileMapOf<File>, Resolver>, keyof Context>> = {}>(...params: Vars extends Record<string, never> ? [r: Resolver] | [r: Resolver, v: Vars] : [r: Resolver, v: Vars]) => TSfyr<TTypeMapOfChild<CoreFileMapOf<File>, Resolver>, [...Path, ...ResolverSegments<Resolver>], Context & Vars, Fetched>;
    map<T>(mapper: TMapper<CoreFileMapOf<File>, Path, Context, Fetched, T>): T[];
    private currentValue;
    private pojo;
    toString(): string;
    maybeAddToBatch(resolverOrTemplate: string): void;
    private get resolver();
    private makeResolver;
    private ensureLastSegmentIsTemplate;
    get sfyr(): TSfyr<CoreFileMapOf<File>, Path, Context, Fetched>;
}
