import { type TResolverValue, type TVariable } from '@stringifyrjs/lib';
import { type TEnsureTemplateVariable } from '@stringifyrjs/lib/dist/src/lib/src/Graph';
import { type ResolverSegments, type TGetTypeMapResolvers, type TStringAccessorPojo, type TTypeMap, type TTypeMapHasChildren, type TTypeMapOfChild, type TTypeMapVar, type TTypeMapVarAsType, type TTypeMapVariablesForResolver } from '@stringifyrjs/lib/dist/src/lib/src/TypeMap-Types';
import { type HasAllKeysIn, type If, type Not, type RemoveLast } from '@stringifyrjs/lib/dist/src/lib/src/utils/Types';
import { type TExtractVarName, type TResolverVarString } from '@stringifyrjs/lib/dist/src/lib/src/Variable';
import { type List } from 'ts-toolbelt';
import { type ResolverBatch } from './ResolverBatch';
type TTypeMapVars_Internal<Vars> = Vars extends object ? {
    [K in keyof Vars]: Vars[K] extends TTypeMapVar ? TTypeMapVarAsType<Vars[K]> : `Var at key ${K & string} is not of type TTypeMapVar`;
} : {};
export type TTypeMapVars<TypeMap> = TTypeMapVars_Internal<'__def' extends keyof TypeMap ? '__variables' extends keyof TypeMap['__def'] ? TypeMap['__def']['__variables'] : {} : {}>;
export type IfAllVariablesHaveBeenProvided<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, Object extends object> = If<HasAllKeysIn<Context, TTypeMapVars<TypeMap>>, Object>;
export type IfSomeVariablesAreMissing<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, Object extends object> = If<Not<HasAllKeysIn<Context, TTypeMapVars<TypeMap>>>, Object>;
export type IfHasNotBeenFetched<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, Object extends object> = If<Not<Fetched>, Object>;
export type IfDoesNotHaveChildrenResolvers<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, Object extends object> = If<Not<TTypeMapHasChildren<TypeMap>>, Object>;
export type IfLastSegmentIsTemplateVariable<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, Object extends object> = If<List.Last<Path> extends TEnsureTemplateVariable<List.Last<Path>> ? true : false, Object>;
export type MissingVariablesForRoot<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean> = Omit<TTypeMapVars<TypeMap>, keyof Context>;
export type MissingVariablesForChild<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, ChildResolver extends TGetTypeMapResolvers<TypeMap>> = Omit<TTypeMapVariablesForResolver<TypeMap, ChildResolver>, keyof Context>;
export type TSfyr<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean> = {
    value: TResolverValue;
    context: Context;
    clone<_Fetched extends boolean>(p: TCloneParams<Fetched>): TSfyr<TypeMap, Path, Context, _Fetched>;
    fetchBoundary(): TSfyr<TypeMap, Path, Context, false>;
    maybeAddToBatch(resolver: string): void;
} & IfAllVariablesHaveBeenProvided<TypeMap, Path, Context, Fetched, {
    pojo(): TStringAccessorPojo<TypeMap>;
    toString(): string;
}> & IfSomeVariablesAreMissing<TypeMap, Path, Context, Fetched, {
    withContext<_Vars extends MissingVariablesForRoot<TypeMap, Path, Context, Fetched>>(p: _Vars): TSfyr<TypeMap, Path, Context & _Vars, Fetched>;
}> & IfHasNotBeenFetched<TypeMap, Path, Context, Fetched, {
    fetch(): Promise<TSfyr<TypeMap, Path, Context, true>>;
}> & IfDoesNotHaveChildrenResolvers<TypeMap, Path, Context, Fetched, {
    resolve<_Child extends TGetTypeMapResolvers<TypeMap>, _Vars extends Partial<MissingVariablesForChild<TypeMap, Path, Context, Fetched, _Child>> = {}>(...params: _Vars extends Record<string, never> ? ([r: _Child] | [r: _Child, v: _Vars]) : ([r: _Child, v: _Vars])): TSfyr<TTypeMapOfChild<TypeMap, _Child>, [
        ...Path,
        ...ResolverSegments<_Child>
    ], Context & _Vars, Fetched>;
}> & {
    [S in keyof Omit<TypeMap, '__def'>]: S extends string ? TSfyr<TypeMap[S], [...Path, S], Context, Fetched> : `TypeMap has a key that is not a string "${S & string}"`;
} & IfLastSegmentIsTemplateVariable<TypeMap, Path, Context, Fetched, {
    map<T>(mapper: TMapper<TypeMap, Path, Context, Fetched, T>): T[];
}>;
export type TMapper<TypeMap extends TTypeMap, Path extends string[], Context extends Record<string, string>, Fetched extends boolean, T> = (p: {
    index: number;
    parent: TSfyr<TypeMap, Path, Context, Fetched>;
    variable: TVariable<TExtractVarName<List.Last<Path>>>;
    child: TSfyr<TypeMap, [
        ...RemoveLast<Path>,
        TResolverVarString<List.Last<Path>, string>
    ], Context, Fetched>;
}) => T;
export type TCloneParams<Fetched extends boolean = boolean> = {
    fetched: Fetched;
    resolverBatch: ResolverBatch<any>;
};
export {};
